Cell Templates

Wijmo interops for popular frameworks allow you to define custom content for FlexGrid cells declaratively, by using each frameworks' own template markup in conjunction with Wijmo's FlexGridCellTemplate class.

Such templates may include arbitrary components and HTML elements, with property and event bindings. All types of grid cells can be defined using templates (data cells, header cells, editors, etc).

This sample shows a grid with the templates for all cell types. The templates can be dynamically enabled or disabled by toggling the checkboxes.

Learn about FlexGrid | FlexGrid API Reference

import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo-core.css'; import './styles.css'; import { FlexGrid } from '@mescius/wijmo.grid'; import * as DataService from './data'; document.readyState === 'complete' ? init() : window.onload = init; function init() { // create the grid with cell templates new FlexGrid('#theGrid', { autoGenerateColumns: false, columns: [ { header: 'Country', binding: 'country', width: '*', cellTemplate: '<img src="resources/${item.country}.png" aria-label="${item.country}"/> ${text}' }, { header: 'Downloads', binding: 'downloads', width: 170, aggregate: 'Sum', cellTemplate: (ctx) => (`<span class=${ctx.item.downloads > 10000 ? "high-val" : "low-val"}>${ctx.text}</span>`) } ], itemsSource: DataService.getCv() }); }
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>Cell Templates</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <main class="container-fluid"> <p> This <b>purejs</b> version of the sample uses the <b>cellTemplate</b> property to customize regular data cells. (The <b>cellTemplate</b> does not apply to header cells or cells in group rows.) </p> <div id="theGrid"></div> </main> </body> </html>
import { CollectionView } from '@mescius/wijmo'; export function getData() { var countries = getCountries(), data = []; for (var i = 0; i < 30; i++) { data.push({ id: i, date: new Date(2015, Math.floor(i / countries.length) % 12, (Math.floor(i / countries.length) + 1) % 28), country: countries[i % countries.length], countryMapped: i % countries.length, downloads: Math.round(Math.random() * 20000), sales: Math.random() * 10000, expenses: Math.random() * 5000, checked: i % 9 == 0 }); } return data; } export function getCountries() { return 'US,Germany,UK,Japan,Italy,Greece'.split(','); } export function getCv() { return new CollectionView(getData(), { sortDescriptions: ['date'], groupDescriptions: ['country'] }); }
.wj-flexgrid { max-height: 350px; max-width: 600px; margin: 10px 0px; } .high-val { color: darkgreen; font-weight: bold; } .low-val { color: darkred; font-weight: bold; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, }, meta: { '*.css': { loader: 'css' }, }, paths: { // paths serve as alias 'npm:': 'node_modules/', 'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/', 'pcdn:': 'https://cdn.jsdelivr.net/npm/' }, // map tells the System loader where to look for things map: { '@mescius/wijmo': 'cdn:@mescius/wijmo/index.js', '@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js', '@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles', '@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures', '@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js', '@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js', '@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js', '@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js', '@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js', '@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js', '@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js', '@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js', '@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js', '@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js', '@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js', '@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js', '@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js', '@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js', '@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js', '@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js', '@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js', '@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js', '@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js', '@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js', '@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js', '@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js', '@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js', '@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js', '@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js', '@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js', '@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js', '@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js', '@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js', '@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js', '@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js', '@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js', '@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js', '@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js', '@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js', '@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js', '@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js', '@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js', '@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js', '@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js', '@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js', '@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js', '@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js', jszip: 'pcdn:jszip@3.8.0/dist/jszip.js', 'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css', css: 'pcdn:systemjs-plugin-css@0.1.37/css.js', 'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js', }, node_modules: { defaultExtension: 'js', }, }, }); })(this);

<template>
<main class="container-fluid">
<p>
Use a <b>wj-flex-grid-cell-template</b> element to define a cell template.
The content of the <b>wj-flex-grid-cell-template</b> element defines the cell content.
The <b>cellType</b> property specifies the type of the cells represented by the template.
Use a <b>v-slot</b> directive to define a variable that contains an object with cell
specific data, including the data item (<b>item</b>), row (<b>row</b>) and
column (<b>col</b>) that the cell represents.
</p>
<p>
Note that column-specific templates should be defined as children of
the corresponding <b>wj-flex-grid-column</b> component, while the others
are defined under the <b>wj-flex-grid</b> element.
</p>
<wj-flex-grid :itemsSource="itemsSource" :allowSorting="false" autoSizeMode="Both" allowResizing="Both"
:deferResizing="true" :initialized="initialized">
<wj-flex-grid-cell-template cellType="TopLeft" v-if="customTopLeft">
№
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="BottomLeft" v-if="customBottomLeft">
Σ
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="RowHeader" v-if="customRowHeader" v-slot="cell">
{{ cell.row.index + 1 }}
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="RowHeaderEdit" v-if="customRowHeaderEdit">
...
</wj-flex-grid-cell-template>
<wj-flex-grid-column header="Country" binding="country" width="*">
<wj-flex-grid-cell-template cellType="Cell" v-if="customCell" v-slot="cell">
<img :src="'resources/' + cell.item.country + '.png'" :aria-label="cell.item.country"/>
{{ cell.item.country }}
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="CellEdit" v-if="customCellEdit" v-slot="cell">
<wj-combo-box :itemsSource="countries" class="cell-editor" v-model="cell.value"
:isEditable="false">
</wj-combo-box>
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="GroupHeader" v-if="customGroupHeader" v-slot="cell">
<input type="checkbox" v-model="cell.row.isCollapsed" />
{{ cell.item.name }} ({{ cell.item.items.length }} items)
</wj-flex-grid-cell-template>
</wj-flex-grid-column>
<wj-flex-grid-column header="Downloads" binding="downloads" :width="170" aggregate="Sum">
<wj-flex-grid-cell-template cellType="ColumnHeader" v-if="customColumnHeader">
<input type="checkbox" v-model="highlightDownloads" />
Downloads
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="Cell" v-if="customCell" v-slot="cell">
<span :style="{ color: highlightDownloads ? (cell.item.downloads > 10000 ? 'green' : 'red') : '' }"
style="font-weight:700">
{{ cell.item.downloads }}
</span>
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="CellEdit" v-if="customCellEdit" v-slot="cell">
<wj-input-number class="cell-editor" v-model="cell.value" :step="1"></wj-input-number>
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="Group" v-if="customGroup" v-slot="cell">
Sum = {{ formatNumber(cell.value, 'N0') }}
</wj-flex-grid-cell-template>
<wj-flex-grid-cell-template cellType="ColumnFooter" v-if="customColumnFooter" v-slot="cell">
Sum = {{ formatNumber(cell.value, 'N0') }}
</wj-flex-grid-cell-template>
</wj-flex-grid-column>
</wj-flex-grid>
<div class="checkbox-list">
<div class="checkbox-list-title">Column level templates:</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" v-model="customCell" /> Cell
</label>
<label class="checkbox">
<input type="checkbox" v-model="customCellEdit" /> CellEdit
</label>
</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" v-model="customColumnHeader" /> ColumnHeader
</label>
<label class="checkbox">
<input type="checkbox" v-model="customColumnFooter" /> ColumnFooter
</label>
</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" v-model="customGroupHeader" /> GroupHeader
</label>
<label class="checkbox">
<input type="checkbox" v-model="customGroup" /> Group
</label>
</div>
<div class="checkbox-list-title">Grid level templates:</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" v-model="customTopLeft" /> TopLeft
</label>
<label class="checkbox">
<input type="checkbox" v-model="customBottomLeft" /> BottomLeft
</label>
</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" v-model="customRowHeader" /> RowHeader
</label>
<label class="checkbox">
<input type="checkbox" v-model="customRowHeaderEdit" /> RowHeaderEdit
</label>
</div>
</div>
</main>
</template>
<script setup>
import * as wjcCore from "@mescius/wijmo";
import * as wjcGrid from "@mescius/wijmo.grid";
import * as dataService from "./data";
import { ref } from "vue";
const itemsSource = ref(dataService.getCv(dataService.getData()));
const countries = ref(dataService.getCountries());
const customTopLeft = ref(true);
const customBottomLeft = ref(true);
const customRowHeader = ref(true);
const customRowHeaderEdit = ref(true);
const customCell = ref(true);
const customCellEdit = ref(true);
const customGroupHeader = ref(true);
const customColumnHeader = ref(true);
const customGroup = ref(true);
const customColumnFooter = ref(true);
const highlightDownloads = ref(true);
function initialized(grid, e) {
grid.columnFooters.rows.push(new wjcGrid.GroupRow());
}
function formatNumber(value, format) {
return wjcCore.Globalize.formatNumber(value, format);
}
</script>
<style>
body {
margin-bottom: 24px;
}
label {
margin-right: 3px;
}
.checkbox-list {
padding: 0 20px;
}
.checkbox-cell {
display: table-cell;
padding-right: 50px;
}
.checkbox-list .checkbox {
margin: 10px 0 0 0;
}
.checkbox-list-title {
font-size: 18px;
margin: 10px 0px 2px -20px;
}
.wj-flexgrid {
max-height: 350px;
max-width: 600px;
margin: 10px 0;
}
.wj-cell .cell-editor {
position: absolute;
left: 0px;
width: 100%;
border-radius: 0px;
margin: -4px 0 -3px 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Cell Templates</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
import { CollectionView } from '@mescius/wijmo';
export function getData() {
var countries = getCountries(), data = [];
for (var i = 0; i < 30; i++) {
data.push({
id: i,
date: new Date(2015, Math.floor(i / countries.length) % 12, (Math.floor(i / countries.length) + 1) % 28),
country: countries[i % countries.length],
countryMapped: i % countries.length,
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
checked: i % 9 == 0
});
}
return data;
}
export function getCountries() {
return 'US,Germany,UK,Japan,Italy,Greece'.split(',');
}
export function getCv() {
return new CollectionView(getData(), {
sortDescriptions: ['date'],
groupDescriptions: ['country']
});
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
//
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { DataService } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjInputModule, WjGridModule, BrowserModule, FormsModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
countries: string[];
data: wjcCore.CollectionView;
customTopLeft = true;
customRowHeader = true;
customRowHeaderEdit = true;
customCell = true;
customCellEdit = true;
customColumnHeader = true;
customGroupHeader = true;
customGroup = true;
customColumnFooter = true;
customBottomLeft = true;
highlightDownloads = true;
//
@ViewChild('grid', { static: true }) grid: wjcGrid.FlexGrid;
//
constructor(@Inject(DataService) dataSvc: DataService) {
this.countries = dataSvc.getCountries();
this.data = dataSvc.getCv(dataSvc.getData());
}
//
ngAfterViewInit() {
if (this.grid) {
this.grid.columnFooters.rows.push(new wjcGrid.GroupRow());
}
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Cell Templates</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<p>
Use an <b>ng-template</b> element with the <b>wjFlexGridCellTemplate</b> directive
to define a cell template.
The content of the <b>ng-template</b> element defines the cell content.
The <b>cellType</b> property specifies the type of the cells represented by the template.
The <b>cell</b> local template variable contains an object with cell specific data,
including the data item (<b>item</b>), row (<b>row</b>) and column (<b>col</b>) that
the cell represents.
</p>
<p>
Note that column-specific templates should be defined as children of
the corresponding <b>wj-flex-grid-column</b> component, while the others
are defined under the <b>wj-flex-grid</b> element.
</p>
<wj-flex-grid #grid [itemsSource]="data" [allowSorting]="false" [autoSizeMode]="'Both'" [allowResizing]="'Both'"
[deferResizing]="true">
@if (customTopLeft) {
<ng-template wjFlexGridCellTemplate [cellType]="'TopLeft'">
№
</ng-template>
}
@if (customBottomLeft) {
<ng-template wjFlexGridCellTemplate [cellType]="'BottomLeft'">
Σ
</ng-template>
}
@if (customRowHeader) {
<ng-template wjFlexGridCellTemplate [cellType]="'RowHeader'" let-cell="cell">
{{cell.row.index + 1}}
</ng-template>
}
@if (customRowHeaderEdit) {
<ng-template wjFlexGridCellTemplate [cellType]="'RowHeaderEdit'">
...
</ng-template>
}
<wj-flex-grid-column header="Country" binding="country" width="*">
@if (customCell) {
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<img src="resources/{{cell.item.country}}.png" [attr.aria-label]="cell.item.country" />
{{cell.item.country}}
</ng-template>
}
@if (customCellEdit) {
<ng-template wjFlexGridCellTemplate [cellType]="'CellEdit'" let-cell="cell">
<wj-combo-box [itemsSource]="countries" class="cell-editor" [(selectedValue)]="cell.value"
[isEditable]="false" [isRequired]="false" [placeholder]="'Select a Country'">
</wj-combo-box>
</ng-template>
}
@if (customGroupHeader) {
<ng-template wjFlexGridCellTemplate [cellType]="'GroupHeader'" let-cell="cell">
<input type="checkbox" [(ngModel)]="cell.row.isCollapsed" />
{{cell.item.name}} ({{cell.item.items.length}} items)
</ng-template>
}
</wj-flex-grid-column>
<wj-flex-grid-column header="Downloads" binding="downloads" [width]="170" [aggregate]="'Sum'">
@if (customColumnHeader) {
<ng-template wjFlexGridCellTemplate [cellType]="'ColumnHeader'">
<input type="checkbox" [(ngModel)]="highlightDownloads" />
Downloads
</ng-template>
}
@if (customCell) {
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<span [style.color]="highlightDownloads ? (cell?.item?.downloads > 10000 ? 'green' : 'red') : null"
style="font-weight:700">
{{cell.item.downloads}}
</span>
</ng-template>
}
@if (customCellEdit) {
<ng-template wjFlexGridCellTemplate [cellType]="'CellEdit'" let-cell="cell">
<wj-input-number class="cell-editor" [(value)]="cell.value" [step]="1"></wj-input-number>
</ng-template>
}
@if (customGroup) {
<ng-template wjFlexGridCellTemplate [cellType]="'Group'" let-cell="cell">
Sum = {{cell.value | number:'1.0-0'}}
</ng-template>
}
@if (customColumnFooter) {
<ng-template wjFlexGridCellTemplate [cellType]="'ColumnFooter'" let-cell="cell">
Sum: {{cell.value | number:'1.0-0'}}
</ng-template>
}
</wj-flex-grid-column>
</wj-flex-grid>
<div class="checkbox-list">
<div class="checkbox-list-title">Column level templates:</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customCell" /> Cell
</label>
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customCellEdit" /> CellEdit
</label>
</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customColumnHeader" /> ColumnHeader
</label>
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customColumnFooter" /> ColumnFooter
</label>
</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customGroupHeader" /> GroupHeader
</label>
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customGroup" /> Group
</label>
</div>
<div class="checkbox-list-title">Grid level templates:</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customTopLeft" /> TopLeft
</label>
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customBottomLeft" /> BottomLeft
</label>
</div>
<div class="checkbox-cell">
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customRowHeader" /> RowHeader
</label>
<label class="checkbox">
<input type="checkbox" [(ngModel)]="customRowHeaderEdit" /> RowHeaderEdit
</label>
</div>
</div>
</main>
import { Injectable } from '@angular/core';
import * as wjcCore from '@mescius/wijmo';
//
@Injectable()
export class DataService {
// data used to generate random items
getData(): any[] {
var countries = this.getCountries(),
data = [];
for (var i = 0; i < 30; i++) {
data.push({
id: i,
date: new Date(2015, Math.floor(i / countries.length) % 12, (Math.floor(i / countries.length) + 1) % 28),
country: countries[i % countries.length],
countryMapped: i % countries.length,
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
checked: i % 9 == 0
});
}
return data;
}
getCountries(): string[] {
return 'US,Germany,UK,Japan,Italy,Greece'.split(',');
}
getCv(data: any[]): wjcCore.CollectionView {
var dataCv = new wjcCore.CollectionView(data);
dataCv.sortDescriptions.push(new wjcCore.SortDescription('date', true));
dataCv.groupDescriptions.push(new wjcCore.PropertyGroupDescription('country'));
return dataCv;
}
}
body {
margin-bottom: 24px;
}
label {
margin-right: 3px;
}
.checkbox-list {
padding: 0 20px;
}
.checkbox-cell {
display: table-cell;
padding-right: 50px;
}
.checkbox-list .checkbox {
/* width: 50%; */
/* float:left; */
/* width: 100px; */
margin: 10px 0 0 0;
/* display: inline-block; */
}
.checkbox-list-title {
font-size: 18px;
margin: 10px 0px 2px -20px;
}
.wj-flexgrid {
max-height: 350px;
max-width: 600px;
margin: 10px 0;
}
.cell-editor {
position: absolute;
left: 0px;
width: 100%;
border-radius: 0px;
margin: -4px 0 -3px 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjGrid from '@mescius/wijmo.react.grid';
import * as wjInput from '@mescius/wijmo.react.input';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import './app.css';
import { itemsSource, countries } from './data';
function App() {
const [customTopLeft, setCustomTopLeft] = useState(true);
const [customBottomLeft, setCustomBottomLeft] = useState(true);
const [customRowHeader, setCustomRowHeader] = useState(true);
const [customRowHeaderEdit, setCustomRowHeaderEdit] = useState(true);
const [customCell, setCustomCell] = useState(true);
const [customCellEdit, setCustomCellEdit] = useState(true);
const [customGroupHeader, setCustomGroupHeader] = useState(true);
const [customColumnHeader, setCustomColumnHeader] = useState(true);
const [customGroup, setCustomGroup] = useState(true);
const [customColumnFooter, setCustomColumnFooter] = useState(true);
const [highlightDownloads, setHighlightDownloads] = useState(true);
// Wijmo event handlers
const initialized = useEvent((grid) => {
grid.columnFooters.rows.push(new wjcGrid.GroupRow());
});
// The template used in more than one cell type is defined as a method.
// The rest of the template functions are inlined in FlexGridCellTemplate
// definitions.
const totalTemplate = (context) => {
return <React.Fragment>
Sum: {wjcCore.Globalize.formatNumber(context.value, 'N0')}
</React.Fragment>;
};
// Another template function.
const rowHeaderTemplate = (context) => context.row.index + 1;
//
return (<main className="container-fluid">
<p>
Use a <b>FlexGridCellTemplate</b> component to define a cell template.
The <b>cellType</b> property specifies the type of cell represented by
the template, and the <b>template</b> <i>render prop</i> accepts a
function that renders the cells content.
The function parameter receives an object with the cell-specific data,
including the data item (<b>item</b>), row (<b>row</b>), and column
(<b>col</b>) that the cell represents.
</p>
<p>
Note that column-specific templates should be defined as children of
the corresponding <b>FlexGridColumn</b> component, while the others
are defined as children of the <b>FlexGrid</b> component.
</p>
<wjGrid.FlexGrid itemsSource={itemsSource} allowSorting={false} autoSizeMode="Both" allowResizing="Both" deferResizing={true} initialized={initialized}>
{
// To conditionally disable a template, we can just assign
// the 'template' property with a null value.
}
<wjGrid.FlexGridCellTemplate cellType="TopLeft" template={customTopLeft
? (context) => '№'
: null}/>
{
// An alternative way to conditionally disable a template is
// to exclude the FlexGridCellTemplate element from the rendering
// element tree.
}
{customBottomLeft
? <wjGrid.FlexGridCellTemplate cellType="BottomLeft" template={(context) => <span>Σ</span>}/>
: null}
{
// The template function definition can be inlined like in the templates
// above, or defined as a component method like shown in this template.
}
<wjGrid.FlexGridCellTemplate cellType="RowHeader" template={customRowHeader ? rowHeaderTemplate : null}/>
<wjGrid.FlexGridCellTemplate cellType="RowHeaderEdit" template={customRowHeaderEdit
? (context) => '...'
: null}/>
<wjGrid.FlexGridColumn header="Country" binding="country" width="*">
<wjGrid.FlexGridCellTemplate cellType="Cell" template={customCell
? (context) => {
return <React.Fragment>
<img src={`resources/${context.item.country}.png`} aria-label={`${context.item.country}`}/> {context.item.country}
</React.Fragment>;
}
: null}/>
<wjGrid.FlexGridCellTemplate cellType="CellEdit" template={customCellEdit
? (context) => {
return <wjInput.ComboBox className="cell-editor" itemsSource={countries} isEditable={false} selectedValue={context.value} selectedIndexChanged={(cb) => context.value = cb.selectedValue}>
</wjInput.ComboBox>;
}
: null}/>
<wjGrid.FlexGridCellTemplate cellType="GroupHeader" template={customGroupHeader
? (context) => {
return <React.Fragment>
<input type="checkbox" checked={context.row.isCollapsed} onChange={e => context.row.isCollapsed = e.target.checked}/>
{context.item.name} ({context.item.items.length} items)
</React.Fragment>;
}
: null}/>
</wjGrid.FlexGridColumn>
<wjGrid.FlexGridColumn header="Downloads" binding="downloads" width={170} aggregate="Sum">
<wjGrid.FlexGridCellTemplate cellType="ColumnHeader" template={customColumnHeader
? (context) => {
return <React.Fragment>
<input type="checkbox" checked={highlightDownloads} onChange={(e) => {
setHighlightDownloads(e.target.checked);
}}/>
Downloads
</React.Fragment>;
}
: null}/>
<wjGrid.FlexGridCellTemplate cellType="Cell" template={customCell
? (context) => {
let style = {
fontWeight: 700,
color: ''
}, downloads = context.item.downloads;
if (highlightDownloads) {
style.color = downloads > 10000 ? 'green' : 'red';
}
return <span style={style}>
{downloads}
</span>;
}
: null}/>
<wjGrid.FlexGridCellTemplate cellType="CellEdit" template={customCellEdit
? (context) => {
return <wjInput.InputNumber className="cell-editor" step={1} value={context.value} valueChanged={(inpNum) => context.value = inpNum.value}>
</wjInput.InputNumber>;
}
: null}/>
{
// The same totalTemplate render function is used in the two
// templates below. Because of this, it's better to define it
// as the component method, and assign the 'template' property
// with the reference to it.
}
<wjGrid.FlexGridCellTemplate cellType="Group" template={customGroup ? totalTemplate : null}/>
<wjGrid.FlexGridCellTemplate cellType="ColumnFooter" template={customColumnFooter ? totalTemplate : null}/>
</wjGrid.FlexGridColumn>
</wjGrid.FlexGrid>
<div className="checkbox-list">
<div className="checkbox-list-title">Column level templates:</div>
<div className="checkbox-cell">
<label className="checkbox">
<input type="checkbox" checked={customCell} onChange={e => setCustomCell(e.target.checked)}/>
Cell
</label>
<label className="checkbox">
<input type="checkbox" checked={customCellEdit} onChange={e => setCustomCellEdit(e.target.checked)}/>
CellEdit
</label>
</div>
<div className="checkbox-cell">
<label className="checkbox">
<input type="checkbox" checked={customColumnHeader} onChange={e => setCustomColumnHeader(e.target.checked)}/>
ColumnHeader
</label>
<label className="checkbox">
<input type="checkbox" checked={customColumnFooter} onChange={e => setCustomColumnFooter(e.target.checked)}/>
ColumnFooter
</label>
</div>
<div className="checkbox-cell">
<label className="checkbox">
<input type="checkbox" checked={customGroupHeader} onChange={e => setCustomGroupHeader(e.target.checked)}/>
GroupHeader
</label>
<label className="checkbox">
<input type="checkbox" checked={customGroup} onChange={e => setCustomGroup(e.target.checked)}/>
Group
</label>
</div>
<div className="checkbox-list-title">Grid level templates:</div>
<div className="checkbox-cell">
<label className="checkbox">
<input type="checkbox" checked={customTopLeft} onChange={e => setCustomTopLeft(e.target.checked)}/>
TopLeft
</label>
<label className="checkbox">
<input type="checkbox" checked={customBottomLeft} onChange={e => setCustomBottomLeft(e.target.checked)}/>
BottomLeft
</label>
</div>
<div className="checkbox-cell">
<label className="checkbox">
<input type="checkbox" checked={customRowHeader} onChange={e => setCustomRowHeader(e.target.checked)}/>
RowHeader
</label>
<label className="checkbox">
<input type="checkbox" checked={customRowHeaderEdit} onChange={e => setCustomRowHeaderEdit(e.target.checked)}/>
RowHeaderEdit
</label>
</div>
</div>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Cell Templates</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
label {
margin-right: 3px;
}
.checkbox-list {
padding: 0 20px;
}
.checkbox-cell {
display: table-cell;
padding-right: 50px;
}
.checkbox-list .checkbox {
margin: 10px 0 0 0;
}
.checkbox-list-title {
font-size: 18px;
margin: 10px 0px 2px -20px;
}
.wj-flexgrid {
max-height: 350px;
max-width: 600px;
margin: 10px 0;
}
.cell-editor {
position: absolute;
left: 0px;
width: 100%;
border-radius: 0px;
margin: -4px 0 -3px 0;
}
import * as wjcCore from '@mescius/wijmo';
function getData() {
var countries = getCountries(), data = [];
for (var i = 0; i < 30; i++) {
data.push({
id: i,
date: new Date(2015, Math.floor(i / countries.length) % 12, (Math.floor(i / countries.length) + 1) % 28),
country: countries[i % countries.length],
countryMapped: i % countries.length,
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
checked: i % 9 == 0
});
}
return data;
}
function getCountries() {
return ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
}
function getCv(data) {
var dataCv = new wjcCore.CollectionView(data);
dataCv.sortDescriptions.push(new wjcCore.SortDescription('date', true));
dataCv.groupDescriptions.push(new wjcCore.PropertyGroupDescription('country'));
return dataCv;
}
export const itemsSource = getCv(getData());
export const countries = getCountries();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);